您的位置:首页 > 其它

HDU 2795 Billboard【线段树好题,单点更新】

2017-01-07 22:02 435 查看


Billboard

Time Limit: 20000/8000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 20458    Accepted Submission(s): 8490


Problem Description

At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu,
and other important information.

On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.

Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.

When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.

If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university).

Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.

 

Input

There are multiple cases (no more than 40 cases).

The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.

Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.

 

Output

For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can't be put on the billboard,
output "-1" for this announcement.

 

Sample Input

3 5 5
2
4
3
3
3

 

Sample Output

1
2
1
3
-1

 

Author

hhanger@zju

 

Source

HDOJ 2009 Summer Exercise(5)

原题链接:http://acm.hdu.edu.cn/showproblem.php?pid=2795

题意:有个公告板,大小为h*w,要贴n张公告,每个公告的长度是k,高度固定为1,公告放的要尽可能靠上并尽可能靠左,依次给出一张公告,要求这个公告在满足要求的情况下放在了第几层。

思路:按照线段树的做法的话,因为公告的高度固定为1,可以对公告板的高度进行线段花费,将其现在的宽度值存起来,然后每次遍历从左子树开始往下走,知道走到叶子节点满足要求即可。

一般人很难想到用线段树解决,中间也有好多细节要注意,详见代码。

参考博客:http://blog.csdn.net/libin56842/article/details/12977663

这篇博客的方法也不错,值得借鉴。http://blog.csdn.net/jarily/article/details/8629840

AC代码:

#include <iostream>
#include <cstdio>
#include <algorithm>
using namespace std;
const int maxn= 200000+5;
int h,w;
int ans;
struct Node
{
int l,r,maxx;
} node[maxn<<2];
void PushUp(int k)
{
node[k].maxx=max(node[k<<1].maxx,node[k<<1|1].maxx);
}
void BuildTree(int l,int r,int k)
{
node[k].l=l;
node[k].r=r;
node[k].maxx=w;
//因为初始是每个节点的最大值均为w
//所以可以省去PushUp(k);
if(l==r)
{
return;
}
int mid=(l+r)>>1;
BuildTree(l,mid,k<<1);
BuildTree(mid+1,r,k<<1|1);
//PushUp(k);
}
void UpdateTree(int i,int x)
{
if(node[i].l==node[i].r)
{
node[i].maxx-=x;
ans=node[i].l;
return;
}
if(x<=node[i<<1].maxx)
UpdateTree(i<<1,x);
else
UpdateTree(i<<1|1,x);
PushUp(i);
}
int main()
{
int n;
while(cin>>h>>w>>n)
{
if(h>n)
h=n;
//根据题意,因为最多放n个公告,
//占用的最大高度也只有n,优化建树的高度
BuildTree(1,h,1);
int x;
while(n--)
{
ans=-1;
scanf("%d",&x);
if(node[1].maxx>=x)
UpdateTree(1,x);
printf("%d\n",ans);
}
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息